/*
 * $Id:$
 */

package $block{jfcpackagename}.app.jfcworkstate;

import static jp.jasminesoft.util.ExcelFunction.*;

import java.io.File;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeSet;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.beanutils.MethodUtils;
import org.apache.commons.lang3.ArrayUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.log4j.Logger;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.springframework.beans.factory.NoSuchBeanDefinitionException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.transaction.TransactionStatus;
import org.springframework.transaction.support.TransactionCallbackWithoutResult;
import org.springframework.transaction.support.TransactionTemplate;

import jp.jasminesoft.jfc.ActionParameter;
import jp.jasminesoft.jfc.IActionParameter;
import jp.jasminesoft.jfc.IMessage;
import jp.jasminesoft.jfc.JFCDataAccessManager;
import jp.jasminesoft.jfc.JFCErrorManager;
import jp.jasminesoft.jfc.JFCUtils;
import jp.jasminesoft.jfc.PrimaryKeyUtils;
import jp.jasminesoft.jfc.ProcessBean;
import jp.jasminesoft.jfc.app.ContainerBase;
import jp.jasminesoft.jfc.app.EntityHelper;
import jp.jasminesoft.jfc.app.MailMessageManager;
import jp.jasminesoft.jfc.app.ReplaceMap;
import jp.jasminesoft.jfc.core.filter.BlankFilter;
import jp.jasminesoft.jfc.core.pattern.DecorativeArrayFilter;
import jp.jasminesoft.jfc.core.util.CollectionUtils;
import jp.jasminesoft.jfc.core.util.ReflectionUtils;
import jp.jasminesoft.jfc.core.util.StoreModelUtils;
import jp.jasminesoft.jfc.dao.CriteriaConverter;
import jp.jasminesoft.jfc.dao.DaoHelper;
import jp.jasminesoft.jfc.dao.DataBindingContext;
import jp.jasminesoft.jfc.error.Jfcerror;
import jp.jasminesoft.jfc.hibernate.DetachedCriteria;
import jp.jasminesoft.jfc.meta.EntityMeta;
import jp.jasminesoft.jfc.meta.MultiPropertyMeta;
import jp.jasminesoft.jfc.meta.PropertyMetaBase;
import jp.jasminesoft.jfc.model.mailmessage.Mailmessage;
import jp.jasminesoft.jfc.service.JFCEntityService;
import jp.jasminesoft.util.SourceGeneratorUtil;
import jp.jasminesoft.util.StringUtil;
import $block{jfcpackagename}.app.WorkFlowManager;
import $block{jfcpackagename}.model.jfcparticipant_setting.Participants;
import $block{jfcpackagename}.model.jfcworkflow_setting_p.JfcworkflowSettingP;
import $block{jfcpackagename}.model.jfcworkstate.Jfcworkstate;
import $block{jfcpackagename}.model.jfcworkstate.JfcworkstateMeta;
import $block{jfcpackagename}.model.jfcworkstate_lp.JfcworkstateLp;
import $block{jfcpackagename}.model.jfcworkstate_p.JfcworkstateP;
import jp.jasminesoft.workflow.WorkEvent;

/**
 * JfcworkstateServiceImpl
 *
 * @version $Revision:$ $Date:$
 * @author JasmineSoft
 */

public class JfcworkstateServiceImpl implements JfcworkstateService
{
    private final static Logger logger = Logger.getLogger(JfcworkstateServiceImpl.class);

    private final static String JfcworkflowSettingPArrayAttrName = "__jfc_JfcworkstateServiceImpl.JfcworkflowSettingPArray";

    /** transactionTemplate(PROPAGATION_REQUIRED) */
    @Autowired
    @Qualifier("RequiredTransactionTemplate")
    protected TransactionTemplate requiredTransactionTemplate;

    private JFCErrorManager errorManager;

    @Autowired
    public void setJFCErrorManager(JFCErrorManager errorManager) {
        this.errorManager = errorManager;
    }

    public JFCErrorManager getJFCErrorManager() {
        return errorManager;
    }

    public JfcworkstateLp getJfcworkstateLp(String modelname, String pkey, ActionParameter p) {
        $block{jfcpackagename}.model.jfcworkstate_lp.JfcworkstateLp jfcworkstate_lp = null;
        $block{jfcpackagename}.model.jfcworkstate.Jfcworkstate[] jfcworkstate_ary = null;

        jp.jasminesoft.jfc.service.JFCEntityService entityService = (jp.jasminesoft.jfc.service.JFCEntityService)p.appctx.getBean("JfcworkstateEntityService");
        JfcworkstateMeta meta = new JfcworkstateMeta();
        DetachedCriteria criteria = DetachedCriteria.forClass(meta.entityClass());
        criteria.eq(meta.modelname, modelname);
        criteria.eq(meta.modelpkey, pkey);
        criteria.addOrder(Order.asc(meta.id.name()));
        List<Jfcworkstate> list = entityService.find(criteria);
        jfcworkstate_ary = list.toArray(new Jfcworkstate[list.size()]);
        $block{jfcpackagename}.model.jfcworkstate_l.JfcworkstateL
            jfcworkstate_l = (($block{jfcpackagename}.app.jfcworkstate.JfcworkstateLHelper)p.appctx.getBean("JfcworkstateLHelper")).s2l(jfcworkstate_ary, p);
        jfcworkstate_lp = (($block{jfcpackagename}.app.jfcworkstate.JfcworkstateLpHelper)p.appctx.getBean("JfcworkstateLpHelper")).l2lp(jfcworkstate_l, p);

        if (jfcworkstate_lp == null) {
            jfcworkstate_lp = new $block{jfcpackagename}.model.jfcworkstate_lp.JfcworkstateLp();
        } else {
            String _displaytype = (String)p.request.getAttribute("__jfc_control.workflow.displaytype");
            if (StringUtils.isNotBlank(_displaytype)) {
                int fileIndex = 0;
                for ($block{jfcpackagename}.model.jfcworkstate_lp.Item _item : jfcworkstate_lp.getItem()) {
                    $block{jfcpackagename}.model.jfcworkstate_lp.Username[] _usernames = _item.getUsername();
                    if (_usernames != null && _usernames.length > 0) {
                        ProcessBean _pbean = (ProcessBean)p.appctx.getBean("ShowJuserProcessBean");
                        _pbean.setActionParameter(p);
                        _pbean.setParameter("userid", _usernames[0].getContent());
                        Object _op = null;
                        try {
                            _op = _pbean.process();
                        } finally {
                            _pbean.release();
                        }
                        if (_op != null && _op instanceof jp.jasminesoft.jfc.model.juser.Juser) {
                            jp.jasminesoft.jfc.model.juser.Juser _juser = (jp.jasminesoft.jfc.model.juser.Juser)_op;
                            String[] _itemnames = _displaytype.split(",");
                            for (String _itemname : _itemnames) {
                                _itemname = _itemname.trim();
                                // file check.
                                String _itemname_file = _itemname + "_jshfilename";
                                String _getter = SourceGeneratorUtil.getterMethod(_itemname_file);
                                Object o = null;
                                try {
                                    o = MethodUtils.invokeMethod(_juser, _getter, null);
                                } catch (NoSuchMethodException e) {
                                } catch (IllegalAccessException e) {
                                } catch (InvocationTargetException e) {
                                } catch (Exception e) {
                                }
                                if (o != null && o instanceof String) {
                                    String _filename = (String)o;
                                    if (File.separatorChar != '\\') {
                                        _filename = _filename.replace('\\', '/');
                                    }
                                    File _file = new File(_filename);
                                    if (!_file.isAbsolute()) {
                                        File _catalinahome_bin_dir =
                                            new File(System.getProperty("catalina.home"), "bin");
                                        _file = new File(_catalinahome_bin_dir, _filename); 
                                    }
                                    if (_file.exists()) {
                                        p.request.getSession().setAttribute("jfcworkstate_filename" + fileIndex, _file.getAbsolutePath());
                                        _usernames[0].setContent(_filename);
                                        //System.out.println("_file="+_file.getAbsolutePath());
                                        break;
                                    }
                                }
                                _getter = SourceGeneratorUtil.getterMethod(_itemname);
                                try {
                                    o = MethodUtils.invokeMethod(_juser, _getter, null);
                                } catch (NoSuchMethodException e) {
                                } catch (IllegalAccessException e) {
                                } catch (InvocationTargetException e) {
                                } catch (Exception e) {
                                }
                                if (o != null && o instanceof String) {
                                    _usernames[0].setContent((String)o);
                                    //System.out.println("set "+_itemname+","+o);
                                    break;
                                }
                            }
                        }
                    }
                    fileIndex++;
                }
            }
        }
        return jfcworkstate_lp;
    }

    //@Transactional
    public void insertJfcworkstate(Jfcworkstate jfcworkstate, ActionParameter p) {
        insertJfcworkstate(jfcworkstate, true, p);
    }

    public void insertJfcworkstate(final Jfcworkstate jfcworkstate, final boolean isUpdateWorkflowModelitem, final ActionParameter p) {
        // 内部メソッドからの呼び出しの場合は @Transactional は動作しないので、
        // transactionTemplate を利用する。
        requiredTransactionTemplate.execute(
                new TransactionCallbackWithoutResult() {
                    /** {@inheritDoc} **/
                    @Override
                    protected void doInTransactionWithoutResult(
                            TransactionStatus status) {
                        insertJfcworkstate0(jfcworkstate,
                                isUpdateWorkflowModelitem, p);
                    }
                });
    }

    private void insertJfcworkstate0(Jfcworkstate jfcworkstate, boolean isUpdateWorkflowModelitem, ActionParameter p) {
        SessionFactory sessionFactory = (SessionFactory) p.appctx.getBean("sessionFactory");
        org.hibernate.Session session = sessionFactory.getCurrentSession();

        StringBuilder errmsg = new StringBuilder();
        InsertJfcworkstateProcessBean pbean = null;
        $block{jfcpackagename}.app.CacheManager cman = null;
        try {
            pbean = (InsertJfcworkstateProcessBean) p.appctx.getBean("InsertJfcworkstateProcessBean");
            pbean.setActionParameter(p);
            cman = $block{jfcpackagename}.app.CacheManager.getInstance(p);
            Jfcworkstate pbeanJfcworkstate = new Jfcworkstate();
            BeanUtils.copyProperties(pbeanJfcworkstate, jfcworkstate);
            String mainModelname = (String) p.request.getAttribute("jfc_workflow_mainModelId");
            if (StringUtils.isNotBlank(mainModelname)) {
                pbeanJfcworkstate.setModelname(mainModelname);
            	jfcworkstate.setMainModelname(mainModelname);
            }
            String runUpdateMsg = pbean.runInsert(session, null, pbeanJfcworkstate);
            if (StringUtils.isNotBlank(runUpdateMsg)) {
                errmsg.append(runUpdateMsg);
                throw new RuntimeException(errmsg.toString());
            }
            // BR8315 2014.12.18
            // When data is not deleted, the workflow item of the model is also updated.
            String screentype = (String) p.request.getAttribute(IActionParameter.ScreenTypeRequestName);
            if (isUpdateWorkflowModelitem && // 2015.01.26 Consideration for customized developers.
                !StringUtils.equalsIgnoreCase("delete", screentype)) {
                updateWorkflowModelitem(jfcworkstate, p);
            }
            List<Jfcworkstate> list = 
                (List<Jfcworkstate>)p.request.getAttribute(JfcworkstateService.JfcworkstateAttrName);
            if (list == null) {
                list = new ArrayList<Jfcworkstate>();
                p.request.setAttribute(JfcworkstateService.JfcworkstateAttrName, list);
            }
            list.add(pbeanJfcworkstate);
            // Run flow event script.
            executeFlowEventScript(jfcworkstate, p);
        } catch(RuntimeException e) {
            throw e;
        } catch(Exception e) {
            errmsg.append(pbean.convertErrorMessage(e, new String[][] {{ "id", JFCUtils.getRValue("jfcworkstate.id", p.locale) }}));
            logger.warn(JFCUtils.logmsg(p, errmsg.toString()), e);
            throw new RuntimeException(e);
        } finally {
            cman.clearJfcworkstate_insert(jfcworkstate);
        }
    }

    public void deleteJfcworkstate(Jfcworkstate deleteJfcworkstate, ActionParameter p) {
        if (deleteJfcworkstate == null) {
            return;
        }
        jp.jasminesoft.jfc.service.JFCEntityService entityService =
            (jp.jasminesoft.jfc.service.JFCEntityService)p.appctx.getBean("JfcworkstateEntityService");
        JfcworkstateMeta meta = new JfcworkstateMeta();
        DetachedCriteria criteria = DetachedCriteria.forClass(meta.entityClass());
        criteria.eq(meta.modelname, deleteJfcworkstate.getModelname());
        criteria.eq(meta.modelpkey, deleteJfcworkstate.getModelpkey());
        List<Jfcworkstate> jfcworkstateList = entityService.find(criteria);
        if (jfcworkstateList == null || jfcworkstateList.size() == 0) {
            return;
        }
        for (Jfcworkstate jfcworkstate : jfcworkstateList) {
            entityService.delete(jfcworkstate.getId(), true);
        }
    }

    public void updateWorkflowModelitem(Jfcworkstate jfcworkstate, ActionParameter p) {
        String modelname = jfcworkstate.getModelname();
        String modelpkey = jfcworkstate.getModelpkey();
        String[] primaryKeyNames = JFCUtils.getPrimarykeyName(p, modelname);
        WorkFlowManager wman = WorkFlowManager.getInstance(p);

        // Get the data of the workflow to be updated.
        jp.jasminesoft.jfc.app.EntityHelper helper = (jp.jasminesoft.jfc.app.EntityHelper)p.appctx.getBean(StringUtil.capFirst(modelname)+"Helper");
        jp.jasminesoft.jfc.service.JFCEntityService entityService = (jp.jasminesoft.jfc.service.JFCEntityService)p.appctx.getBean(StringUtil.capFirst(modelname)+"EntityService");

        ContainerBase<?> op = null;
        boolean checkLocked = false;
        op = (ContainerBase<?>) p.request.getAttribute("jfcWorkflowEntity");
        if (op == null) {
            op = entityService.findById(helper.getPrimarykey(modelpkey), true);
            checkLocked = true;
        }
        if (op == null) {
            logger.error("Data access error. modelname="+modelname+",modelpkey="+modelpkey);
            Object[] ep = { modelname };
            Jfcerror jfcerror = errorManager.getJfcerror("error.dbaccess", ep, p.locale);
            p.errors.addJfcerror(jfcerror);
            throw new RuntimeException(jfcerror.getContent());
        }
        // Update creator, returnee, approved subject, processed layer ID, processing node name.
        try {
            Class c = op.getClass();
            Object ret;
            Method setAdmitUserMethod = c.getMethod("setJfcWorkflowAdmitUser", new Class[]{String.class});
            Method setProcessedLayerIdMethod = c.getMethod("setJfcWorkflowProcessedLayerId", new Class[]{String.class});
            Method setCurrentNodeMethod = c.getMethod("setJfcWorkflowCurrentNode", new Class[]{String.class});

            Object[] admitUser;
            Object[] processedLayerId;
            Object[] currentNode;
            Object[] NULL = new Object[] { null };

            String modelId = modelname;
            if (StringUtils.isNotBlank(jfcworkstate.getMainModelname())) {
            	modelId = jfcworkstate.getMainModelname();
            }
            // End workflow
            if (WorkEvent.End.toString().equals(jfcworkstate.getEvent())) {
                admitUser = NULL;
                String processedLayerIdStr = jfcworkstate.getProcessedLayerid();
                if (processedLayerIdStr != null) {
                    // Considering that the decision was made on the way.
                    processedLayerIdStr = wman.getLastLayerId(modelname, modelpkey, p);
                    processedLayerId = new Object[] { new String(processedLayerIdStr) };
                } else {
                    processedLayerId = NULL;
                }
                currentNode = NULL;
            } else if (WorkEvent.Reject.toString().equals(jfcworkstate.getEvent()) ||
                       WorkEvent.Cancel.toString().equals(jfcworkstate.getEvent())) {
                // In case of rejection, cancellation.
                admitUser = NULL;
                processedLayerId = NULL;
                currentNode = NULL;
            } else {
            	String[] admitUsers = wman.getCurrentAdmitUsersAndGroup(modelId, modelpkey, p);
                Boolean isJfcAdmitUsersOrGroupFromScript =
                		(Boolean) p.request.getAttribute(wman.AdmitUsersOrGroupFromScript);
                if (isJfcAdmitUsersOrGroupFromScript != null && isJfcAdmitUsersOrGroupFromScript) {
                	admitUsers = null; 
                }
                if (admitUsers != null) {
                    admitUser = new Object[] { new String(StringUtils.join(admitUsers, ","))};
                } else {
                    admitUser = NULL;
                }

                String processedLayer = jfcworkstate.getProcessedLayerid();
                if (processedLayer != null) {
                    processedLayerId = new Object[] { new String(processedLayer) };
                } else {
                    processedLayerId = NULL;
                }

                String currentNodeName = wman.getCurrentNode(modelId, modelpkey, p);
                if (currentNodeName != null) {
                    currentNode = new Object[] { new String(currentNodeName) };
                } else {
                    currentNode = NULL;
                }
            }
            ret = setAdmitUserMethod.invoke(op, admitUser);
            ret = setProcessedLayerIdMethod.invoke(op, processedLayerId);
            ret = setCurrentNodeMethod.invoke(op, currentNode);
            String reqkey = "__jfc_workflowupdate_"+modelname+"-"+modelpkey;
            p.request.setAttribute(reqkey, Boolean.TRUE);
            entityService.update(op, checkLocked);
            putCache(op, p);
            p.request.removeAttribute(reqkey);
        } catch(RuntimeException e) {
            throw e;
        } catch(NoSuchMethodException e) {
            throw new RuntimeException(e);
        } catch(IllegalAccessException e) {
            throw new RuntimeException(e);
        } catch(Exception e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * Put the cache that was erased by the previous EntityService # update ().
     * Special handling to prevent DB access by SELECT in another transaction within the sendMail() method.
     * (Since it can not be acquired by SELECT at the time of new registration.) @see BR9343
     * @param entity Store model to be processed for workflow processing
     * @param p ActionParameter
     */
    @SuppressWarnings("unchecked")
    private void putCache(ContainerBase<?> entity, ActionParameter p ) {
        @SuppressWarnings("rawtypes")
        DaoHelper daoHelper = StoreModelUtils.daoHelper(entity.getClass(), p);
        daoHelper.putCache(entity);
    }

    public String getCreateUserName(String modelname, String pkey, ActionParameter p) {
        Jfcworkstate startws = getStartJfcworkstate(modelname, pkey, p);
        if (startws != null) {
            return startws.getUsername();
        }
        return null;
    }

    public Jfcworkstate getStartJfcworkstate(String modelname, String pkey, ActionParameter p) {
        jp.jasminesoft.jfc.service.JFCEntityService entityService = (jp.jasminesoft.jfc.service.JFCEntityService)p.appctx.getBean("JfcworkstateEntityService");
        JfcworkstateMeta meta = new JfcworkstateMeta();
        DetachedCriteria criteria = DetachedCriteria.forClass(meta.entityClass());
        criteria.eq(meta.modelname, modelname);
        criteria.eq(meta.modelpkey, pkey);
        criteria.eq(meta.event, WorkEvent.Start.toString());
        List<Jfcworkstate> list = entityService.find(criteria);
        if (list.isEmpty()) {
            return null;
        }
        return list.get(0);
    }

    /**
     * Send mail corresponding to the jfcworkstate.
     * 
     * @param jfcworkstate Jfcworkstate
     * @param p ActionParameter
     */
    public void sendMail(Jfcworkstate _jfcworkstate, ActionParameter p) {
        String modelname = _jfcworkstate.getModelname();

        // BR4651 2009.06.08 Change from WEvent to WorkEvent.
        String event = _jfcworkstate.getEvent();
        WorkEvent wevent = null;
        for (WorkEvent _e : WorkEvent.values()) {
            if (_e.toString().equals(event)) {
                wevent = _e;
                break;
            }
        }
        if (wevent == null) {
            return;
        }

        // BR5282 2010.01.25
        // Change Rewind event to Back event.
        if (WorkEvent.Rewind.toString().equals(event)) {
            wevent = WorkEvent.Back;
        }

        JFCDataAccessManager dam = (JFCDataAccessManager)p.appctx.getBean("JFCDataAccessManager");
        String[] primaryKeyNames = JFCUtils.getPrimarykeyName(p, modelname);
        String[] pkeys = null;
        if (primaryKeyNames != null && primaryKeyNames.length > 1) {
            pkeys = _jfcworkstate.getModelpkey().split(PrimaryKeyUtils.PKEY_SEPARATOR_REGEXP());
        } else {
            pkeys = new String[] { _jfcworkstate.getModelpkey() };
        }
        Map<String,String> _obj_map = dam.getReplaceMap(modelname, pkeys, ((ActionParameter)p));
        if (p.errors.sizeJfcerror() > 0) {
            return;
        }
        if (_obj_map == null) {
            return;
        }

        JfcworkstateP _jfcworkstate_p = (($block{jfcpackagename}.app.jfcworkstate.JfcworkstatePHelper)p.appctx.getBean("JfcworkstatePHelper")).s2p(_jfcworkstate, ((ActionParameter)p), $block{jfcpackagename}.app.jfcworkstate.JfcworkstatePHelper.SHOW);
        Map<String,String> _jfcworkstate_map = (($block{jfcpackagename}.app.jfcworkstate.ReplaceMapHelper)p.appctx.getBean("JfcworkstateReplaceMapHelper")).get(_jfcworkstate_p, ((ActionParameter)p));
        WorkFlowManager wman = WorkFlowManager.getInstance(p);
        JfcworkflowSettingP wfs_p = wman.getJfcworkflowSettingP(_jfcworkstate, p);
        if (wfs_p != null) {
            sendMail(_obj_map, _jfcworkstate, wevent, _jfcworkstate_p, _jfcworkstate_map, wfs_p, p);
        } else {
            logger.error("No jfcworkflow_setting is found. modelname="+modelname+",pkey="+_jfcworkstate.getModelpkey()+",flowid="+_jfcworkstate.getFlowid());
        }
        return;
    }

    private void sendMail(
            Map<String,String> _obj_map,
            Jfcworkstate _jfcworkstate,
            WorkEvent wevent, 
            JfcworkstateP _jfcworkstate_p,
            Map<String,String> _jfcworkstate_map,
            JfcworkflowSettingP _wfs_p,
            ActionParameter p)
    {
        Map<String,String> _wfs_map = (($block{jfcpackagename}.app.jfcworkflow_setting.ReplaceMapHelper)p.appctx.getBean("JfcworkflowSettingReplaceMapHelper")).get(_wfs_p, ((ActionParameter)p));

        Integer _layerid = null;
        // BR7505 2015.01.29
        // When the cancellation process is performed, since the processed layer ID is null, the processed layer ID is set to '1' for mail transmission.
        String _processedLayerid;
        if (WorkEvent.Cancel.toString().equals(_jfcworkstate.getEvent())) {
            _processedLayerid = "1";
        } else {
            _processedLayerid = _jfcworkstate.getParticipantid();
        }

        LOOP:for ($block{jfcpackagename}.model.jfcworkflow_setting_p.MailSetting ms : _wfs_p.getMailSetting()) {
            $block{jfcpackagename}.model.jfcworkflow_setting_p.Mnode[] _mnodes = ms.getMnode();
            if (_mnodes != null && _mnodes.length > 0) {
                if (_processedLayerid != null && !"0".equals(_processedLayerid)) {
                    _layerid = _mnodes[0].getParticipantsjshidJshpkey() + 1;
                    if (!_layerid.toString().equals(_processedLayerid)) {
                        continue;
                    }
                }
            }
            for ($block{jfcpackagename}.model.jfcworkflow_setting_p.Mstype mstype : ms.getMstype()) {
                if (mstype.getInvalid()) {
                    continue;
                }
                if (!mstype.getChoose()) {
                    continue;
                }
                int mstypeid = mstype.getId();
                if (wevent.ordinal() == mstypeid-1) {
                    $block{jfcpackagename}.model.jfcworkflow_setting_p.MailTemplate mt = null;
                    for ($block{jfcpackagename}.model.jfcworkflow_setting_p.MailTemplate _mt : ms.getMailTemplate()) {
                        if (_mt.getInvalid()) {
                            continue;
                        }
                        if (!_mt.getChoose()) {
                            continue;
                        }
                        mt = _mt;
                        break;
                    }
                    if (mt == null) {
                        break;
                    }

                    String mid = mt.getId();

                    sendMail(
                            _obj_map,
                            _jfcworkstate,
                            _jfcworkstate_p,
                            _jfcworkstate_map,
                            _wfs_p,
                            _wfs_map,
                            mid, p);
                    break LOOP;
                }
            }
        }
    }

    private boolean sendMail(
            Map<String,String> _obj_map,
            Jfcworkstate _jfcworkstate,
            JfcworkstateP _jfcworkstate_p,
            Map<String,String> _jfcworkstate_map,
            JfcworkflowSettingP _wfs_p,
            Map<String,String> _wfs_map,
            String mid,
            ActionParameter p)
    {
        ReplaceMap<String,String> replaceMap =
            new ReplaceMap<String,String>(_obj_map); 
        replaceMap.putAll(_jfcworkstate_map); 
        replaceMap.putAll(_wfs_map);

        // send mail.
        MailMessageManager mailman = (MailMessageManager)p.appctx.getBean("MailMessageManager");
        Mailmessage mm = mailman.getMailmessage(mid, (ActionParameter)p);
        if (mm == null) {
            p.logger.warn("mail id "+mid+" is not found. skip the sendmail process.");
            return false;
        }
        Mailmessage n_mm = mailman.replace(mm, replaceMap);
        boolean status =
            mailman.send(n_mm, getJFCErrorManager(), "", p);
        p.request.setAttribute(
                IMessage.StatusRequestName, new Boolean(status));
        return status;
    }

    public void processJfcworkstate(
            Jfcworkstate jfcworkstate, ActionParameter p)
    {
        WorkFlowManager wman = WorkFlowManager.getInstance(p);
        // BR4651 2009.06.16
        processJfcworkstate(wman, jfcworkstate, p);
    }

    private void processJfcworkstate(
            WorkFlowManager wman, Jfcworkstate jfcworkstate, ActionParameter p)
    {
        String modelname = jfcworkstate.getModelname();
        String modelpkey = jfcworkstate.getModelpkey();
        String username = jfcworkstate.getUsername();
        String event = jfcworkstate.getEvent();
        String participant = jfcworkstate.getParticipant();

        String workflowActionUser;
        if (participant != null && participant.startsWith("groupid:")) {
            workflowActionUser = participant;
        } else {
            workflowActionUser = username;
        }

        // BR4651 2009.06.08
        wman.action(modelname, modelpkey, workflowActionUser, event, p);

        List<Jfcworkstate> list = 
            (List<Jfcworkstate>)p.request.getAttribute(JfcworkstateService.JfcworkstateAttrName);
        p.request.removeAttribute(JfcworkstateService.JfcworkstateAttrName);

        // BR8220 2014.12.17
        // When the decision button is pushed in the middle of the node, the final flow participant ID is acquired and registered.
        if (WorkEvent.End.toString().equals(event)) {
            jfcworkstate.setProcessedLayerid(wman.getLastLayerId(modelname, modelpkey, p));
        }
        // Also update the item that holds the workflow state of the workflow model.
        // BR 7950, 2014.06.11 Update before sending mail.
        Boolean b = (Boolean)p.request.getAttribute("__jfc_workflow_end_"+modelname+"_"+modelpkey);
        if (b == null || !b.booleanValue()) {//2014.08.30
            updateWorkflowModelitem(jfcworkstate, p);
        }

        boolean isSendMail = false;
        for (Jfcworkstate _jfcworkstate : list) {
            if (WorkEvent.End.toString().equals(_jfcworkstate.getEvent())) {
                // Send mail by decision flow.
                sendMail(_jfcworkstate, p);
                isSendMail = true;
                break;
            }
        }
        if (!isSendMail) {
            sendMail(jfcworkstate, p);
        }
    }

    /**
     * Return current flow participant node name (application, approval etc.) of workflow data.
     *
     * @param modelname
     * @param pkey
     * @param p ActionParameter
     */
    public static String FLOWSTATUS(String modelname, String pkey, ActionParameter p) {
        return flowstatus(modelname, pkey, p);
    }

    /**
     * Return current flow participant node name (application, approval etc.) of workflow data.
     *
     * @param p ActionParameter
     * @param modelname
     * @param pkey
     */
    public static String PARTICIPANTNODENAME(ActionParameter p, String modelname, String pkey) {
        return flowstatus(modelname, pkey, p);
    }

    public static String PARTICIPANTNODENAME(ActionParameter p, String modelname, String layerId, String pkey) {
        return flowstatus(modelname, pkey, layerId, p);
    }

    public static String PARTICIPANTNODENAME(ActionParameter p, String modelname, String layerId, String... pkeys) {
        return flowstatus(modelname, JFCUtils.aggregatePrimaryKey(pkeys), layerId, p);
    }

    public static String flowstatus(String modelname, String pkey, ActionParameter p) {
        WorkFlowManager wman = WorkFlowManager.getInstance(p);
        String layerId = wman.getProcessedLayerId(modelname, pkey, p);
        return wman.getParticipantNodename(modelname, pkey, layerId, p);
    }

    public static String flowstatus(String modelname, String pkey, String layerId, ActionParameter p) {
        WorkFlowManager wman = WorkFlowManager.getInstance(p);
        return wman.getParticipantNodename(modelname, pkey, layerId, p);
    }

    public static String WFNEXTUSERID(ActionParameter p, String modelname, String... pkeys) {
        return WFNEXTUSERID(p, modelname, JFCUtils.aggregatePrimaryKey(pkeys));
    }

    public static String WFNEXTUSERID(ActionParameter p, String modelname, String pkey) {
        WorkFlowManager wman = WorkFlowManager.getInstance(p);
        String waitLayerid = wman.getCurrentJfcworkstateWaitLayerid(modelname, pkey, p);
        if (waitLayerid == null) {
            return null;
        }
        Participants[] participants_ary = wman.getParticipants(modelname, pkey, p);
        if (participants_ary == null) {
        	return null;
        }
        String _userid = null;	
        String participantName;
        for (Participants participants : participants_ary) {
            if (!waitLayerid.equals(participants.getLayerId())) {
            	continue;
            }
            // If the value can be obtained from the flow participant setting, return the user ID.
            participantName = participants.getParticipantName();
            if (StringUtils.isNotBlank(participantName)) {
            	return getUsername(modelname, participantName, p);
            }
            // If the flow participant can not acquire, it returns the execution result of the script.
            participantName = wman.getAdmitUsersOrGroupFromScript(modelname, pkey, participants.getParticipantScript(), p);
            if (StringUtils.isBlank(participantName) || StringUtils.startsWith(participantName, WorkFlowManager.GroupidParticipantHeader)) {
                // Set null if the execution result of the script is the group ID.
                return null;
            }
            if (!StringUtils.contains(participantName, "|")) {
            	return getUsername(modelname, participantName, p);
            }
            // If multiple users are returned, they are replaced with a comma separator.
            String[] participantNames = StringUtils.split(participantName, "|");
            _userid = getUsername(modelname, participantNames[0], p);
            String _userid2;
            for (int i=1; i<participantNames.length; i++) {
            	_userid2 = getUsername(modelname, participantNames[i], p);
            	if (StringUtils.isBlank(_userid2)) {
            		continue;
            	}
            	_userid = _userid + "," + _userid2;
            }
            return _userid;
        }
        return _userid;
    }

    protected static String getUsername(String modelname, String participantName, ActionParameter p) {
        WorkFlowManager wman = WorkFlowManager.getInstance(p);
    	String username = wman.getUsername(modelname, participantName, p);
    	if (!StringUtils.startsWith(username, WorkFlowManager.GroupidParticipantHeader)) {
            return username;
        }
    	return "";
    }

    public static Integer[] WFNEXTGROUPID(ActionParameter p, String modelname, String... pkeys) {
        return WFNEXTGROUPID(p, modelname, JFCUtils.aggregatePrimaryKey(pkeys));
    }

    public static Integer[] WFNEXTGROUPID(ActionParameter p, String modelname, String pkey) {
        WorkFlowManager wman = WorkFlowManager.getInstance(p);
        String waitLayerid = wman.getCurrentJfcworkstateWaitLayerid(modelname, pkey, p);
        if (waitLayerid == null) {
            return new Integer[0];
        }
        Participants[] participants_ary = wman.getParticipants(modelname, pkey, p);
        if (participants_ary == null) {
            return new Integer[0];
        }
        Integer _groupid = null;
        Set<Integer> _groupids = new TreeSet<Integer>();
        for (Participants participants : participants_ary) {
            if (!waitLayerid.equals(participants.getLayerId())) {
                continue;
            }
            _groupid = participants.getParticipantGroupid();
            if (_groupid != null && _groupid >= 0) {
                // When acquiring the group ID of the flow participant setting.
                _groupids.add(Integer.valueOf(_groupid));
            } else {
                // If the group ID can not be obtained, check the execution result of the script.
                String admitUsersOrGroup = wman.getAdmitUsersOrGroupFromScript(modelname, pkey, participants.getParticipantScript(), p);
                if (!StringUtils.startsWith(admitUsersOrGroup, WorkFlowManager.GroupidParticipantHeader)) {
                    // If the execution result of the script is not the group ID, check the next flow participant setting.
                    continue;
                }
                _groupids.add(Integer.valueOf(StringUtils.substringAfter(admitUsersOrGroup, WorkFlowManager.GroupidParticipantHeader)));
            }
        }
        return _groupids.toArray(new Integer[_groupids.size()]);
    }

    public static String WFCURRENTUSERID(ActionParameter p, String modelname, String... pkeys) {
        return WFCURRENTUSERID(p, modelname, JFCUtils.aggregatePrimaryKey(pkeys));
    }

    public static String WFCURRENTUSERID(ActionParameter p, String modelname, String pkey) {
        WorkFlowManager wman = WorkFlowManager.getInstance(p);
        //System.out.println("* CURRENTNODEUSERID, modelname="+modelname+",pkey="+pkey);
        //String flowid = wman.getParticipantNodename(modelname, pkey, p);
        //System.out.println("* flowid="+flowid);
        String processed_layerid = wman.getProcessedLayerId(modelname, pkey, p);
        if (processed_layerid == null) {
            return null;
        }	
        //System.out.println("* processed_layerid="+processed_layerid);
        //String wait_layerid = wman.getWaitLayerid(modelname, pkey, flowid, p);
        //System.out.println("* wait_layerid="+wait_layerid);

        //String participantId = wman.getParticipantId(modelname, pkey, processed_layerid, p);
        //System.out.println("* participantId="+participantId);

        //String[] userids = wman.getCurrentAdmitUsers(modelname, pkey, p);
        //System.out.println("* userids="+Arrays.asList(userids));

        String _userid = null;	
        Participants[] participants_ary = wman.getParticipants(modelname, pkey, p);
        if (participants_ary != null) {
            for (Participants participants : participants_ary) {
                if (processed_layerid.equals(participants.getLayerId())) {
                //System.out.println("* processed_layerid="+processed_layerid);
                //System.out.println(participants);
                //System.out.println("* name="+participants.getParticipantName());
                //System.out.println("* pname="+wman.getUserIdByProxy(modelname, participants.getParticipantName()));
                //System.out.println("* pname2="+wman.getUsername(modelname, participants.getParticipantName()));
                //System.out.println("* group="+participants.getParticipantGroupid());
                    _userid = wman.getUserIdByProxy(modelname, participants.getParticipantName(), p);
                    break;
                }
            }
        }
        return _userid;
    }

    public static Integer WFCURRENTGROUPID(ActionParameter p, String modelname, String... pkeys) {
        return WFCURRENTGROUPID(p, modelname, JFCUtils.aggregatePrimaryKey(pkeys));
    }

    public static Integer WFCURRENTGROUPID(ActionParameter p, String modelname, String pkey) {
        WorkFlowManager wman = WorkFlowManager.getInstance(p);
        String processed_layerid = wman.getProcessedLayerId(modelname, pkey, p);
        if (processed_layerid == null) {
            return null;
        }
        Integer _groupid = null;
        Participants[] participants_ary = wman.getParticipants(modelname, pkey, p);
        if (participants_ary != null) {
            for (Participants participants : participants_ary) {
                if (processed_layerid.equals(participants.getLayerId())) {
                    _groupid = participants.getParticipantGroupid();
                    break;
                }
            }
        }
        return (_groupid != null && _groupid >= 0) ? _groupid : null;
    }

    public static java.sql.Timestamp WFLASTPROCESSDATE(ActionParameter p, String modelname, String pkey) {
        WorkFlowManager wman = WorkFlowManager.getInstance(p);
        //System.out.println("* CURRENTNODEUSERID, modelname="+modelname+",pkey="+pkey);
        return wman.getCurrentJfcworkstateDataAsTimestamp(modelname, pkey, "insertDate_", p);
    }

    public static String WFLASTEVENT(ActionParameter p, String modelname, String... pkeys) {
        return WFLASTEVENT(p, modelname, JFCUtils.aggregatePrimaryKey(pkeys));
    }

    public static String WFLASTEVENT(ActionParameter p, String modelname, String pkey) {
        WorkFlowManager wman = WorkFlowManager.getInstance(p);
        String _key = wman.getLastWorkflowEvent(modelname, pkey, p);
        if (_key != null && _key.length() > 0) {
            return JFCUtils.getRValue("__jfc_common.workflow."+_key, p.locale);
        }
        return "";
    }

    /**
     * Acquires e-mail addresses of suspended person and suspended group. 
     * If there are multiple e-mail addresses, concatenate them with ",".
     * 
     * @param p ActionParameter
     * @param entity Store model for workflow.
     * @param userModelId The id of the model that manages the mail address of the suspended person.
     * @param useridItemName Logon ID item name of suspended person.
     * @param userEmailItemName mail address item name of suspended person.
     * @param groupModelId The id of the model that manages the mail address of the suspended group.
     * @param groupidItemName group id item name of suspended group.
     * @param groupEmailItemName mail address item name of suspended group.
     * @return mailaddress
     */
    public static <T extends ContainerBase<T>, S extends ContainerBase<S>>
            String WFNEXTMAIL(ActionParameter p, S entity, String userModelId,
                    String useridItemName, String userEmailItemName,
                    String groupModelId, String groupidItemName,
                    String groupEmailItemName) {
        String userEmails = WFNEXTUSERIDMAIL(p, entity, userModelId,
                useridItemName, userEmailItemName);
        String groupEmails = WFNEXTGROUPIDMAIL(p, entity, groupModelId,
                groupidItemName, groupEmailItemName);
        return JOIN(new BlankFilter().filter(
                new String[] { userEmails, groupEmails }), ",");
    }

    /**
     * Acquires e-mail addresses of suspended person.
     * If there are multiple e-mail addresses, concatenate them with ",".
     * 
     * @param p ActionParameter
     * @param entity Store model for workflow.
     * @param modelId The id of the model that manages the mail address of the suspended person.
     * @param useridItemName Logon ID item name of suspended person.
     * @param emailItemName mail address item name of suspended person.
     * @return mailaddress
     */
    public static <T extends ContainerBase<T>, S extends ContainerBase<S>>
            String WFNEXTUSERIDMAIL(ActionParameter p, S entity, String modelId,
                    String useridItemName, String emailItemName) {
        @SuppressWarnings("unchecked")
        Class<S> sClass = (Class<S>) entity.getClass();

        EntityHelper<S, ?> helper = StoreModelUtils.entityHelper(sClass, p);
        String nextuserid = helper.wf_nextuserid(
                p, StoreModelUtils.getModelId(sClass), entity);

        String[] userids
            = new DecorativeArrayFilter<String>(new BlankFilter()) {
            /** {@inheritDoc} */
            @Override
            protected boolean accept(String userid) {
                userid = userid.trim();
                if (userid.startsWith(
                        WorkFlowManager.GroupidParticipantHeader)) {
                    // Removed when group information was mixed.
                    return false;
                }
                return true;
            }
        }.filter(StringUtils.split(nextuserid, ","));
        if (ArrayUtils.isEmpty(userids)) {
            return null;
        }

        return findEmails(p, modelId, useridItemName, emailItemName, userids);
    }

    /**
     * Acquires e-mail addresses of suspended group,
     * If there are multiple e-mail addresses, concatenate them with ",".
     * 
     * @param p ActionParameter
     * @param entity Store model for workflow.
     * @param modelId The id of the model that manages the mail address of the suspended group.
     * @param groupidItemName group id item name of suspended group.
     * @param emailItemName mail address item name of suspended group.
     * @return mailaddress
     */
    public static <T extends ContainerBase<T>, S extends ContainerBase<S>>
            String WFNEXTGROUPIDMAIL(ActionParameter p, S entity,
                    String modelId, String groupidItemName,
                    String emailItemName) {
        @SuppressWarnings("unchecked")
        Class<S> sClass = (Class<S>) entity.getClass();

        EntityHelper<S, ?> helper = StoreModelUtils.entityHelper(sClass, p);
        Integer[] nextgrouprids = helper.wf_nextgroupid(p, StoreModelUtils.getModelId(sClass), entity);
        if (nextgrouprids == null || nextgrouprids.length == 0) {
            return null;
        }
        return findEmails(p, modelId, groupidItemName, emailItemName, nextgrouprids);
    }

    /**
     * Get the mail address.
     * If there are multiple e-mail addresses, concatenate them with ",".
     * 
     * @param p ActionParameter
     * @param modelId The id of the model that manages the mail address,
     * @param idItemName 
     * @param emailItemName
     * @return mailaddress
     */
    private static <T extends ContainerBase<T>> String findEmails(
            ActionParameter p, String modelId, String idItemName,
            String emailItemName, Object... values) {

        @SuppressWarnings("unchecked")
        Class<T> clazz
                = (Class<T>) StoreModelUtils.getStoreModelClass(modelId, p);

        CriteriaConverter<?> criteriaConverter;
        try {
            criteriaConverter = StoreModelUtils.criteriaConverter(clazz, p);
        } catch(NoSuchBeanDefinitionException e) {
            criteriaConverter = new CriteriaConverter<Object>(clazz);
        }
        DetachedCriteria criteria = criteriaConverter.defaultCriteria();
        EntityMeta<?> targetmeta = StoreModelUtils.meta(clazz);
        PropertyMetaBase<?> idItemMeta
                = ReflectionUtils.getPrivateField(targetmeta, idItemName);
        ReflectionUtils.invokePrivateMethod(criteria, "eq",
                new Class[] {idItemMeta.getClass(), Object[].class},
                new Object[] {idItemMeta, values});

        JFCEntityService<T, ?> service
                = StoreModelUtils.entityService(clazz, p);
        DataBindingContext context = new DataBindingContext();
        context.setTargetItemSet(new HashSet<String>(Arrays.asList(
                new String[] { idItemName, emailItemName })));
        List<T> list = service.find(criteria, context);
        Set<String> emails = new TreeSet<String>(); // Remove same address.
        for(T target : list) {
            PropertyMetaBase<String> meta = 
                    ReflectionUtils.getPrivateField(targetmeta, emailItemName);
            if (meta instanceof MultiPropertyMeta) {
                CollectionUtils.add(emails, StoreModelUtils.getValue(
                        target, (MultiPropertyMeta<String>) meta));
            } else {
                CollectionUtils.add(emails,
                        StoreModelUtils.getValue(target, meta));
            }
        }
        // Remove empty string.
        emails.remove("");
        return JOIN(emails.toArray(new String[emails.size()]), ",");
    }

    /**
     * Perform the parameter setting before registering the workflow in the DB.
     * 
     * @param jfcworkstate Jfcworkstate.modelname,modelpkey,event,comment are needed.
     * @param p ActionParameter
     */
    public void setJfcworkstateParameter(Jfcworkstate jfcworkstate, ActionParameter p) {
        String modelname = jfcworkstate.getModelname();
        String modelpkey = jfcworkstate.getModelpkey();
        WorkFlowManager wman = WorkFlowManager.getInstance(p);

        // 2009.09.16
        Integer flowid = wman.getFlowId(modelname, modelpkey, p);
        // Since data whose flow ID can not be acquired by WorkFlowManager#getFlowId is registered by CSV upload, new registered event data is registered.
        if (flowid == null || flowid == 0) {
            try {
                // Acquire the flow ID from the request object.
                flowid = Integer.valueOf(p.request.getParameter("participants_id"));
            } catch(NumberFormatException nfe) {
            }
            // Register "new registration" event.
            insertStartJfcworkstate(modelname, modelpkey, flowid, p);
        } else {
            // When an application is made outside the application node, it is regarded as an error.
            if (WorkEvent.Application.toString().equals(jfcworkstate.getEvent())) {
                String currentNodeName = wman.getCurrentNode(modelname, modelpkey, p);
                if (!WorkFlowManager.APPLICATION_NODE_NAME.equals(currentNodeName)) {
                    throw new RuntimeException(
                            WORKFLOW_ALREADYAPPLY_ERROR_CODE);
                }
            }
        }

        jfcworkstate.setFlowid(flowid);
        // BR4651 2009.06.08
        // Correct it so that the logon user is set for the processor as the workflow engine is changed.
        jfcworkstate.setUsername(p.user.getUsername());
        // BR4924 2009.08.28
        // Change to the method of registering the node name so that the node that processed it from the stored procedure, etc.
        // 2009.09.16
        // Acquire the node name waiting for processing and change it so that the processed flow participant ID is saved.
        String currentLayerId = wman.getCurrentNode(modelname, modelpkey, p);
        String participantId = wman.getParticipantId(modelname, modelpkey, currentLayerId, p);
        jfcworkstate.setParticipantid(participantId);
        // In the case of application / approval, the hierarchical ID which processed was set.
        String processedLayerId = null;
        // 2009.09.18
        // At the time of remand, in order to set the node immediately before the hierarchical ID waiting to be processed, obtain the hierarchical ID waiting to be processed.
        String waitLayerId = wman.getWaitLayerid(modelname, modelpkey, jfcworkstate.getEvent(), p);

        if (WorkEvent.Application.toString().equals(jfcworkstate.getEvent()) ||
            WorkEvent.Admit.toString().equals(jfcworkstate.getEvent())) {
        	if (StringUtils.isBlank(waitLayerId)) {
        	    processedLayerId = participantId;
        	} else {
        		processedLayerId = String.valueOf(Integer.parseInt(waitLayerId) - 1);
        	}
        } else if (WorkEvent.Back.toString().equals(jfcworkstate.getEvent())) {
            // In case of remand, get return destination.
            // Set the layer ID of the return destination.
            boolean isBackToApplicant = false;
            if (flowid != null) {
                isBackToApplicant = wman.isBackToApplicant(modelname, flowid, p);
            }
            if (isBackToApplicant) {
                processedLayerId = "0";
                waitLayerId = "1";
                jfcworkstate.setEvent(WorkEvent.Rewind.toString());
            } else {
                try {
                    // At the time of remand, the node immediately before the layer ID waiting to be processed is set.
                    processedLayerId = String.valueOf(Integer.parseInt(waitLayerId) - 1);
                } catch (NumberFormatException nfe) {
                }
            }
        }
        if (processedLayerId != null) {
            jfcworkstate.setProcessedLayerid(processedLayerId);
        } else {
            jfcworkstate.setProcessedLayerid(currentLayerId);
        }
        // 2009.09.16
        // Register a node waiting to be processed.
        jfcworkstate.setWaitLayerid(waitLayerId);
    }

    private void insertStartJfcworkstate(String modelname, String modelpkey, Integer flowid, ActionParameter p) {
        Jfcworkstate jfcworkstate = new Jfcworkstate();
        jfcworkstate.setFlowid(flowid);
        jfcworkstate.setModelname(modelname);
        jfcworkstate.setModelpkey(modelpkey);
        jfcworkstate.setUsername(p.user.getUsername());
        jfcworkstate.setProcessedLayerid("0");
        jfcworkstate.setWaitLayerid("1");
        jfcworkstate.setEvent(WorkEvent.Start.toString());
        insertJfcworkstate(jfcworkstate, p);
    }

    /** {@inheritDoc} **/
    @Override
    public <E extends ContainerBase<E>> void insertJfcworkstate(
            E entity, EntityHelper<E, ?> entityHelper,
            ActionParameter p) {
        Jfcworkstate jfcworkstate = new Jfcworkstate();
        jfcworkstate.setModelname(entityHelper.getEntityName(entity));
        @SuppressWarnings("unchecked")
        Class<E> entityClass = (Class<E>) entity.getClass();
        if (StoreModelUtils.isCompositeKey(entityClass)) {
            jfcworkstate.setModelpkey(
                    entityHelper.getPrimarykeyAsString(entity, p));
        } else {
            jfcworkstate.setModelpkey(
                    String.valueOf(entityHelper.getPrimarykey(entity)));
        }
        jfcworkstate.setFlowid(
                (Integer) p.request.getAttribute("preserved_participants_id"));
        jfcworkstate.setUsername(p.user.getUsername());
        jfcworkstate.setEvent(WorkEvent.Start.toString());
        jfcworkstate.setProcessedLayerid("0");
        jfcworkstate.setWaitLayerid("1");
        p.request.setAttribute("jfcWorkflowEntity", entity);
        insertJfcworkstate(jfcworkstate, p);
        sendMail(jfcworkstate, p);
    }

    private WorkEvent getWorkEvent(String event) {
        WorkEvent wevent = null;
        for (WorkEvent _e : WorkEvent.values()) {
            if (_e.toString().equals(event)) {
                wevent = _e;
                break;
            }
        }
        if (WorkEvent.Rewind.toString().equals(event)) {
            wevent = WorkEvent.Back;
        }
        return wevent;
    }

    private String getProcessedLayerid(Jfcworkstate _jfcworkstate) {
        if (WorkEvent.Cancel.toString().equals(_jfcworkstate.getEvent())) {
            return "1";
        }
        String _processedLayerid = _jfcworkstate.getParticipantid();
        if (_processedLayerid == null && WorkEvent.End.toString().equals(_jfcworkstate.getEvent())) {
            _processedLayerid = _jfcworkstate.getProcessedLayerid();
        }
        return _processedLayerid;
    }

    private $block{jfcpackagename}.model.jfcworkflow_setting_p.EventScriptSetting getFlowEventScriptSetting(
            Jfcworkstate _jfcworkstate,
            WorkEvent wevent,
            JfcworkflowSettingP _wfs_p,
            ActionParameter p)
    {
    	Integer _layerid = null;
    	Integer _endLayerid = null;
        if (WorkEvent.End == wevent) {
       	    WorkFlowManager wman = WorkFlowManager.getInstance(p);
            _endLayerid = Integer.valueOf(wman.getLastLayerId(_jfcworkstate.getModelname(), _jfcworkstate.getModelpkey(), p));
        }
        String _processedLayerid = getProcessedLayerid(_jfcworkstate);
        for ($block{jfcpackagename}.model.jfcworkflow_setting_p.EventScriptSetting ess : _wfs_p.getEventScriptSetting()) {
            $block{jfcpackagename}.model.jfcworkflow_setting_p.Essnode[] _essnodes = ess.getEssnode();
            if (_essnodes == null || _essnodes.length == 0) {
                continue;
            }
            _layerid = _essnodes[0].getParticipantsjshidJshpkey() + 1;
            if (!_layerid.toString().equals(_processedLayerid) && !(_processedLayerid == null && _layerid == 1) &&
            		!(_processedLayerid == null && _layerid == _endLayerid)) {
                continue;
            }
            for ($block{jfcpackagename}.model.jfcworkflow_setting_p.Esstype esstype : ess.getEsstype()) {
                if (esstype.getInvalid() || !esstype.getChoose()) {
                    continue;
                }
                int esstypeid = esstype.getId();
                if (wevent.ordinal() == esstypeid - 1) {
                    return ess;
                }
            }
        }
        return null;
    }

    private String getFlowEventScript(
            Jfcworkstate _jfcworkstate,
            WorkEvent wevent,
            JfcworkflowSettingP _wfs_p,
            ActionParameter p)
    {
        $block{jfcpackagename}.model.jfcworkflow_setting_p.EventScriptSetting ess =
            getFlowEventScriptSetting(_jfcworkstate, wevent, _wfs_p, p);
        if (ess == null) {
            return "";
        }
        return ess.getEventScript().getContent();
    }

    public void executeFlowEventScript(Jfcworkstate _jfcworkstate, ActionParameter p) {
        WorkEvent wevent = getWorkEvent(_jfcworkstate.getEvent());
        if (wevent == null) {
            return;
        }

        WorkFlowManager wman = WorkFlowManager.getInstance(p);
        JfcworkflowSettingP wfs_p = wman.getJfcworkflowSettingP(_jfcworkstate, p);
        if (wfs_p == null) {
            logger.error("No jfcworkflow_setting is found. modelname="+_jfcworkstate.getModelname()+",pkey="+_jfcworkstate.getModelpkey()+",flowid="+_jfcworkstate.getFlowid());
            return;
        }

        String script = getFlowEventScript(_jfcworkstate, wevent, wfs_p, p);
        if (StringUtils.isBlank(script)) {
            return;
        }
        wman.executeScript(_jfcworkstate.getModelname(), _jfcworkstate.getModelpkey(), script, p);
    }
}
