<%--
 $Id: error.jsp 16013 2018-11-30 00:02:21Z nie $
--%>
<%@ page import="jp.jasminesoft.jfc.IActionParameter,
                 jp.jasminesoft.jfc.controller.BaseController"
    pageEncoding="UTF-8" isErrorPage="true" %>
<c:set var="isMobileSafari" value="<%= BaseController.isMobileSafari(request) %>"/>
<c:set var="isFeaturePhone" value="<%= BaseController.isFeaturePhone(request) %>"/>
<fmt:setLocale value="${sessionScope.__jfc_locale}" scope="request"/>
<fmt:setBundle basename="jfcapp"/>

<%!
    org.apache.log4j.Logger logger =
        org.apache.log4j.Logger.getLogger("error.jsp");

    private void outputWarnMessage(String msg, Throwable e) {
        logger.warn(msg, e);
        if (e.getCause() != null) {
            logger.warn(msg+" :cause ", e.getCause());
        }
        if (e instanceof javax.servlet.jsp.JspException) {
            javax.servlet.jsp.JspException jspe =
                (javax.servlet.jsp.JspException)e;
            if (jspe.getRootCause() != null) {
                logger.warn(msg+" :jsp root cause ", jspe.getRootCause());
            }
        }
        if (e instanceof javax.servlet.ServletException) {
            javax.servlet.ServletException se =
                (javax.servlet.ServletException)e;
            if (se.getRootCause() != null) {
                logger.warn(msg+" :servlet root cause ", se.getRootCause());
            }
        }
    }
%>
<%
    boolean isCVE20140094Attack = false; // 2014.04.25
    Throwable throwable = (Throwable) 
        request.getAttribute("javax.servlet.error.exception");

    if (exception != null) {
        outputWarnMessage("jsp error.", exception);
        if (exception instanceof java.lang.IllegalArgumentException) {
            String msg = exception.getMessage();
            if (msg != null && msg.startsWith("Attack: ")) {
                isCVE20140094Attack = true;
            }
        }
    } else if (throwable != null) {
        outputWarnMessage("servlet error.", throwable);
    } else {
        logger.warn("error page. No exception information.");
    }

    Object status_code = 
        request.getAttribute("javax.servlet.error.status_code");
    if (status_code != null) {
        logger.warn("error, status_code="+status_code);
    }

    Object message = request.getAttribute("javax.servlet.error.message");
    if (message != null) {
        logger.warn("error, message="+message);
    }

    Object exception_type = 
        request.getAttribute("javax.servlet.error.exception_type");
    if (exception_type != null) {
        logger.warn("error, exception_type="+exception_type);
    }

    Object request_uri = 
        request.getAttribute("javax.servlet.error.request_uri");
    if (request_uri != null) {
        logger.warn("error, request_uri="+request_uri);
    }
%>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="X-UA-Compatible" content="IE=edge"/>
<meta charset="utf-8"/>
<link rel="icon" href="favicon.ico" type="image/vnd.microsoft.icon">
<link rel="shortcut icon" href="favicon.ico" type="image/vnd.microsoft.icon">
<link rel="stylesheet" type="text/css" href="<fmt:message key='__jfc_common.dojo_webpage_dir'/>/dijit/themes/<c:out value='${sessionScope.__jfc_cssfilename}'/>/<c:out value='${sessionScope.__jfc_cssfilename}'/>.css">
<link rel="stylesheet" type="text/css" href="css/common.css?<c:out value='${applicationScope.__jfc_releaseTimestamp}'/>">
<link rel="stylesheet" type="text/css" href="css/<c:out value='${sessionScope.__jfc_cssfilename}'/>.css?<c:out value='${applicationScope.__jfc_releaseTimestamp}'/>">
<link rel="stylesheet" type="text/css" href="css/<c:out value='${sessionScope.__jfc_fontsizefilename}'/>.css?<c:out value='${applicationScope.__jfc_releaseTimestamp}'/>">
<link rel="stylesheet" type="text/css" href="css/remindPassword.css?<c:out value='${applicationScope.__jfc_releaseTimestamp}'/>">
<link rel="stylesheet" type="text/css" href="css/mycommon.css?<c:out value='${applicationScope.__jfc_releaseTimestamp}'/>">
<link rel="apple-touch-icon" href="wagby-touch-icon.png">
<style type="text/css">
<!--
${__jfc_csscontent}
-->
</style>
<style type="text/css">
  v\:*{
     behavior:url(#default#VML);
  }
</style>

<c:if test="${isMobileSafari}">
<meta name="viewport" content="user-scalable=no, width=device-width, initial-scale=1.0, maximum-scale=1.0">
<link rel="stylesheet" type="text/css" href="system/iui/iui.css"/>
<style type="text/css">
body {
  padding: 10px;
}
</style>
</c:if>
<c:if test="${isFeaturePhone}">
<c:import url="/system/mobileBrowserCSS.jsp"/>
</c:if>
<%
  if (isCVE20140094Attack) {
%>
<title>CVE-2014-0094 Attack</title>
</head>
<body style="background-color:#fff">

<h1>CVE-2014-0094 Attack has detected.</h1>
<%
  } else {
%>
<title><fmt:message key="__jfc_common.title.error"/></title>
</head>
<body class="<c:out value='${sessionScope.__jfc_cssfilename}'/>" style="padding: 10px; overflow: auto;">
<div id="appnameContainer">
  <div><fmt:message key='__jfc_common.webappname'/></div>
</div>
<div class="pagetitle"><fmt:message key="__jfc_common.headline.error"/></div>
<c:import url="../parts/errormsg.jsp"/>
<c:if test="${param.cmsg == null}">
  <p align="left">
  <fmt:message key="__jfc_common.text.sorry"/>
  <br/>
  <fmt:message key="__jfc_common.text.sorry.detail"/>
  <fmt:message key="__jfc_common.text.sorry.copewith"/>
  </p>
  <ol align="left">
  <li><fmt:message key="__jfc_common.text.sorry.where"/></li>
  <li><fmt:message key="__jfc_common.text.sorry.what"/></li>
  <li><fmt:message key="__jfc_common.text.sorry.who"/></li>
  </ol>
  <p align="left">
  <fmt:message key="__jfc_common.text.sorry.check"/>
  </p>
</c:if>
<p align="center">
<c:choose>
<c:when test="${isMobileSafari}">
<form action="mobileSafariMenu.do">
  <input type="submit" class="whiteButton" value="<fmt:message key="__jfc_common.link.return.mainMenu"/>">
</form>
</c:when>
<c:when test="${isFeaturePhone}">
<form action="mobileMenu.do">
  <input type="submit" class="whiteButton" value="<fmt:message key="__jfc_common.link.return.mainMenu"/>">
</form>
</c:when>
<c:otherwise>
<div id="mainMenuLink" style="text-align: center;">
[ <a href="mainMenu.do"><fmt:message key="__jfc_common.link.return.mainMenu"/></a> ]
</div>
<div id="closeWindowButton" style="display: none; text-align: center;">
<button data-dojo-type="dijit/form/Button" type="button" onClick="self.close()"><fmt:message key="__jfc_common.window.close"/></button>
</div>
</c:otherwise>
</c:choose>
</p>
<%
  }
%>
<script type="text/javascript" src="<fmt:message key='__jfc_common.dojo_webpage_dir'/>/dojo/dojo.js" data-dojo-config="async: true"></script>
<script type="text/javascript">
require(["dojo/dom-style", "dojo/parser", "dojo/ready"], function(domStyle, parser, ready) {
  parser.parse();
  ready(function() {
    var href = window.location.href;
    if (href.search(/\/searchList.*\.do/) > 0) {
      domStyle.set("mainMenuLink", "display", "none");
      domStyle.set("closeWindowButton", "display", "");
    }
  });
});
</script>
</body>
</html>
