<%--
 $Id: error.jsp 2635 2009-06-08 11:32:00Z miyagi $
--%>

<%@ page pageEncoding="UTF-8" isErrorPage="true" %>
<fmt:setLocale value="${sessionScope.__jfc_locale}" scope="request"/>
<fmt:setBundle basename="jfcapp"/>

<%!
    org.apache.log4j.Logger logger =
        org.apache.log4j.Logger.getLogger("error.jsp");

    private void outputWarnMessage(String msg, Throwable e) {
        logger.warn(msg, e);
        if (e.getCause() != null) {
            logger.warn(msg+" :cause ", e.getCause());
        }
        if (e instanceof javax.servlet.jsp.JspException) {
            javax.servlet.jsp.JspException jspe =
                (javax.servlet.jsp.JspException)e;
            if (jspe.getRootCause() != null) {
                logger.warn(msg+" :jsp root cause ", jspe.getRootCause());
            }
        }
    }
%>
<%
    Throwable throwable = (Throwable) 
        request.getAttribute("javax.servlet.error.exception");

    if (exception != null) {
        outputWarnMessage("show jsp error page", exception);
    } else if (throwable != null) {
        outputWarnMessage("show servlet error page", throwable);
    } else {
        logger.warn("show error page, exception is nothing");
    }

    Object status_code = 
        request.getAttribute("javax.servlet.error.status_code");
    if (status_code != null) {
        logger.warn("error status_code = "+status_code);
    }

    Object message = request.getAttribute("javax.servlet.error.message");
    if (message != null) {
        logger.warn("error message = "+message);
    }

    Object exception_type = 
        request.getAttribute("javax.servlet.error.exception_type");
    if (exception_type != null) {
        logger.warn("error exception_type = "+exception_type);
    }

    Object request_uri = 
        request.getAttribute("javax.servlet.error.request_uri");
    if (request_uri != null) {
        logger.warn("error request_uri = "+request_uri);
    }
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta name="viewport" content="user-scalable=no,width=device-width">
<meta name="apple-mobile-web-app-capable" content="yes"/>
<link rel="stylesheet" type="text/css" href="system/iui/iui.css"/>
<link rel="stylesheet" type="text/css" href="css/mobileSafari.css"/>
<title><fmt:message key="__jfc_common.title.error"/></title>
</head>
<body>
<div class="toolbar">
<h1 id="pageTitle"></h1>
</div>
<h1><fmt:message key="__jfc_common.headline.error"/></h1>
<p align="left">
<fmt:message key="__jfc_common.text.sorry"/>
<br/>
<fmt:message key="__jfc_common.text.sorry.detail"/>
<fmt:message key="__jfc_common.text.sorry.copewith"/>
</p>
<ol align="left">
<li><fmt:message key="__jfc_common.text.sorry.where"/></li>
<li><fmt:message key="__jfc_common.text.sorry.what"/></li>
<li><fmt:message key="__jfc_common.text.sorry.who"/></li>
</ol>
<p align="left">
<fmt:message key="__jfc_common.text.sorry.check"/>
</p>

<p align="center">
<form action="mobileSafariMenu.do">
  <input type="submit" class="whiteButton" value="<fmt:message key="__jfc_common.link.return.mainMenu"/>">
</form>
</p>

</body>
</html>
