<%--
 $Id: error.jsp 2635 2009-06-08 11:32:00Z miyagi $
--%>

<%@ page pageEncoding="UTF-8" isErrorPage="true" %>
<fmt:setLocale value="${sessionScope.__jfc_locale}" scope="request"/>
<fmt:setBundle basename="jfcapp"/>

<%!
    org.apache.log4j.Logger logger =
        org.apache.log4j.Logger.getLogger("error.jsp");

    private void outputWarnMessage(String msg, Throwable e) {
        logger.warn(msg, e);
        if (e.getCause() != null) {
            logger.warn(msg+" :cause ", e.getCause());
        }
        if (e instanceof javax.servlet.jsp.JspException) {
            javax.servlet.jsp.JspException jspe =
                (javax.servlet.jsp.JspException)e;
            if (jspe.getRootCause() != null) {
                logger.warn(msg+" :jsp root cause ", jspe.getRootCause());
            }
        }
    }
%>
<%
    Throwable throwable = (Throwable) 
        request.getAttribute("javax.servlet.error.exception");

    if (exception != null) {
        outputWarnMessage("show jsp error page", exception);
    } else if (throwable != null) {
        outputWarnMessage("show servlet error page", throwable);
    } else {
        logger.warn("show error page, exception is nothing");
    }

    Object status_code = 
        request.getAttribute("javax.servlet.error.status_code");
    if (status_code != null) {
        logger.warn("error status_code = "+status_code);
    }

    Object message = request.getAttribute("javax.servlet.error.message");
    if (message != null) {
        logger.warn("error message = "+message);
    }

    Object exception_type = 
        request.getAttribute("javax.servlet.error.exception_type");
    if (exception_type != null) {
        logger.warn("error exception_type = "+exception_type);
    }

    Object request_uri = 
        request.getAttribute("javax.servlet.error.request_uri");
    if (request_uri != null) {
        logger.warn("error request_uri = "+request_uri);
    }
%>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta name="viewport" content="user-scalable=no, width=device-width, initial-scale=1.0, maximum-scale=1.0">
<meta name="apple-mobile-web-app-capable" content="yes">
<link rel="stylesheet" type="text/css" href="<fmt:message key='__jfc_common.dojo_webpage_dir'/>/dijit/themes/tundra/tundra.css">
<link rel="stylesheet" type="text/css" href="css/mobile.css"/>
<link rel="stylesheet" type="text/css" href="css/mymobile.css?<c:out value='${applicationScope.__jfc_buildTimestamp}'/>">
<script type="text/javascript" src="<fmt:message key='__jfc_common.dojo_webpage_dir'/>/dojox/mobile/deviceTheme.js"></script>
<script type="text/javascript" src="<fmt:message key='__jfc_common.dojo_webpage_dir'/>/dojo/dojo.js" data-dojo-config="async: true, parseOnLoad: false, paths:{'apphome':'../..'}"></script>
<script type="text/javascript" src="system/common.js?<c:out value='${applicationScope.__jfc_buildTimestamp}'/>" charset="UTF-8"></script>
<title><fmt:message key="__jfc_common.title.error"/></title>
</head>
<body class="tundra" style="visibility: hidden;">
<div data-dojo-type="dojox/mobile/ScrollableView" data-dojo-props="selected: true">
<h1 data-dojo-type="dojox/mobile/Heading" data-dojo-props="label: '<fmt:message key="__jfc_common.title.error"/>', fixed: 'top'">
<button id="jfcToolBarBtnMenu" data-dojo-type="dojox/mobile/ToolBarButton" data-dojo-props="arrow:'left', transition:'slide', transitionDir:-1, href:'mobileMenu.do'"><fmt:message key="__jfc_link.mobileMenu.button.Menu"/></button>
</h1>
<div style="padding: 5px;">
<fmt:message key="__jfc_common.text.sorry"/>
<br/>
<fmt:message key="__jfc_common.text.sorry.detail"/>
<fmt:message key="__jfc_common.text.sorry.copewith"/>
<ol>
<li><fmt:message key="__jfc_common.text.sorry.where"/></li>
<li><fmt:message key="__jfc_common.text.sorry.what"/></li>
<li><fmt:message key="__jfc_common.text.sorry.who"/></li>
</ol>
<fmt:message key="__jfc_common.text.sorry.check"/>
</div>
</div>
<script type="text/javascript">
require(["dojo/_base/kernel", "dojo/parser", "dojo/dom-class", "dojo/query", "dojo/i18n", "dojo/ready"], function(kernel, parser, domClass, query, i18n, ready) {
  ready(function() {
    parser.parse();
<c:if test="${__jfc_maintenanceMode == true}">
    query('h1').forEach(function(node) {
      domClass.add(node, 'pagetitle_under_maintenance');
    });
</c:if>
    for (i in Initializer.initList) {
      (Initializer.initList[i])();
    }
    for (i in Initializer.finList) {
      (Initializer.finList[i])();
    }
    browser_locale = kernel.locale;
    res = i18n.getLocalization("apphome", "common", browser_locale);
  });
});
</script>
</body>
</html>
