<%@ page import="java.io.*,
                 jp.jasminesoft.jfc.*,
                 java.nio.charset.Charset,
                 java.util.*,
                 javax.activation.*,
                 org.apache.log4j.Logger"
         pageEncoding="UTF-8"
         errorPage="/system/error.jsp"
%><%!
    private String getHTTPDate() {
        java.text.SimpleDateFormat formatter =
			new java.text.SimpleDateFormat("E, dd MMM yyyy hh:mm:ss zzz", 
										   java.util.Locale.US);
        formatter.setTimeZone(java.util.TimeZone.getTimeZone("GMT"));
        return formatter.format(new java.util.Date());
    }

    Logger logger = Logger.getLogger("wagbyDownload2");
%><%
  /*
   *  CAUTION: if last line include line feed code after the code "\%\>",
   *           the following errors occur.
   * java.lang.IllegalStateException:
   *   getOutputStream() has already been called for this response
   */

  String xpath = request.getParameter("path");
  if (xpath == null || xpath.length() == 0) {
      logger.info("path is null or zero.");
      return;
  }

  String userid = null;
  jp.jasminesoft.jfc.User user = (jp.jasminesoft.jfc.User)session.getAttribute("__jfc_user");
  if (user != null) {
      userid = user.getUsername();
  }
  String filename = (String)session.getAttribute(xpath);

  if (filename == null || filename.length() == 0) {
      logger.info("filename is null or zero.");
      return;
  }
  if (File.separatorChar != '\\') {
      filename = filename.replace('\\', '/');
  }
  File file = new File(filename);
  if (!file.isAbsolute()) {
      File catalinahome_bin_dir =
          new File(System.getProperty("catalina.home"), "bin");
      file = new File(catalinahome_bin_dir, filename); 
  }
  if (!file.exists()) {
      logger.info("target file "+file.getAbsolutePath()+" is not found.");
%><c:redirect url="/fileNotFound.jsp"/><%
  }

  String fpath = request.getParameter("fname");
  String savefilename = null;
  if (fpath != null && fpath.length() > 0) {
      savefilename = (String)session.getAttribute(fpath);
  }

  String fname;
  if (savefilename != null && savefilename.length() > 0) {
      fname = savefilename;
  } else {
      fname = file.getName();
  }

  int index1 = fname.lastIndexOf('\\');
  int index2 = fname.lastIndexOf('/');
  if (index1 > index2) {
      if (index1 >= 0 && index1+1 < fname.length()) {
          fname = fname.substring(index1+1);
      }
  } else if (index1 < index2) {
      if (index2 >= 0 && index2+1 < fname.length()) {
          fname = fname.substring(index2+1);
      }
  }

  response.setHeader("Expires",getHTTPDate());
  response.setHeader("Pragma","no-cache");
  response.setHeader("Cache-Control","no-store, no-cache, must-revalidate, private");
  response.setHeader("Content-Length", Long.toString(file.length()));

  InputStream istream =
      session.getServletContext().getResourceAsStream("/WEB-INF/mime.types");
  MimetypesFileTypeMap mimetypes =
      new MimetypesFileTypeMap(istream);
  String mimetype = mimetypes.getContentType(fname.toLowerCase());
  Charset download_charset = JFCUtils.getDownloadCharset(mimetype);
  response.setContentType(mimetype+"; charset=" + download_charset.toString());

  String encorded_fname
    = jp.jasminesoft.util.WebStringEncodeUtilities.encodeAttachedFileName(
      fname, request);
  response.setHeader("Content-disposition", "inline; filename=\"" + encorded_fname +"\"");

  BufferedOutputStream output = new BufferedOutputStream(response.getOutputStream());
  BufferedInputStream input = new BufferedInputStream(new FileInputStream(file));

  byte buf[] = new byte[256];
  int len;
  try {
    while ((len = input.read(buf)) != -1) {
        output.write(buf, 0, len);
    }
  } finally {
    try {
        input.close();
    } catch (Exception e) {
    }
    try {
        output.close();
    } catch (Exception e) {
    }
  }

  out.clearBuffer();


  if (fname != null && fname.indexOf(".") > 0) {
      String suffix = fname.substring(fname.lastIndexOf(".")+1);
      if (suffix.equalsIgnoreCase("jpg") ||
          suffix.equalsIgnoreCase("jpeg") ||
          suffix.equalsIgnoreCase("png") ||
          suffix.equalsIgnoreCase("gif") ||
          suffix.equalsIgnoreCase("bmp")) {
          ;
      } else {
          if (userid == null) {
              userid = "Unknown";
          }
          logger.info("("+userid+") Download "+fname);
      }
  }

// 末尾に改行コードがあると java.lang.IllegalStateException が発生するため、
// 次の行で改行は入れないようにして下さい
%>